// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "GUICons.h"
#include "GUIConsDoc.h"
#include "GUIConsView.h"

#define MAINFRM_FILE
#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif



/*---------------------------------*/
/* Constants                       */
/*---------------------------------*/

/*---------------------------------*/
/* Type Definitions                */
/*---------------------------------*/

/*---------------------------------*/
/* Global Variables                */
/*---------------------------------*/

static BOOL m_bInsert=TRUE;


/*---------------------------------*/
/* Function Prototypes             */
/*---------------------------------*/


/*-------------------------------------------------------------------------*/
/* W32GC_SCREEN_SIZE                                                       */
/*                                                                         */
/*-------------------------------------------------------------------------*/
extern "C" void W32GC_Screen_Size(int *row, int *col)
{
 *row=theView->win_size_row;
 *col=theView->win_size_col-1;

}

/*-------------------------------------------------------------------------*/
/* W32GC_KBD_IS_NOT_EMPTY                                                  */
/*                                                                         */
/*-------------------------------------------------------------------------*/
extern "C" int W32GC_Kbd_Is_Not_Empty(void)

{
 return kbd_begin!=kbd_end;
}


/*-------------------------------------------------------------------------*/
/* W32GC_EMIT_BEEP                                                         */
/*                                                                         */
/*-------------------------------------------------------------------------*/
extern "C" void W32GC_Emit_Beep(void)

{
	MessageBeep(MB_ICONEXCLAMATION);
}




/*-------------------------------------------------------------------------*/
/* W32GC_MSG                                                               */
/*                                                                         */
/*-------------------------------------------------------------------------*/
extern "C" void W32GC_Msg(char *s)
{
	AfxMessageBox(s);
}




/*-------------------------------------------------------------------------*/
/* W32GC_INS_MODE                                                          */
/*                                                                         */
/*-------------------------------------------------------------------------*/
extern "C" void W32GC_Ins_Mode(int ins_mode)
{
	m_bInsert = ins_mode;	
	((CMainFrame*)(theApp.m_pMainWnd))->m_wndStatusBar.UpdateWindow();
}




/*-------------------------------------------------------------------------*/
/* W32GC_GET_CHAR0                                                         */
/*                                                                         */
/*-------------------------------------------------------------------------*/
extern "C" int W32GC_Get_Char0(void)
{
 int c;

 WaitForSingleObject(kbd_event,INFINITE);

 EnterCriticalSection(&cs);

 c=kbd_buff[kbd_begin];
 Inc_Buff_Index(kbd_begin);
 if (kbd_begin==kbd_end)
 {
	 kbd_begin=kbd_end=0;
     ResetEvent(kbd_event);
 }

 LeaveCriticalSection(&cs);

 return c;
}




/*-------------------------------------------------------------------------*/
/* W32GC_PUT_CHAR                                                          */
/*                                                                         */
/*-------------------------------------------------------------------------*/
extern "C" void W32GC_Put_Char(int c)

{
	theView->Put_Char(c);
}
	



/*-------------------------------------------------------------------------*/
/* W32GC_ERASE                                                             */
/*                                                                         */
/*-------------------------------------------------------------------------*/
extern "C" void W32GC_Erase(int c)

{
	theView->Erase(c);
}
	



/*-------------------------------------------------------------------------*/
/* W32GC_BACKD                                                             */
/*                                                                         */
/*-------------------------------------------------------------------------*/
extern "C" void W32GC_Backd(int n)
{
	theView->Backd(n);
}




/*-------------------------------------------------------------------------*/
/* W32GC_FORWD                                                             */
/*                                                                         */
/*-------------------------------------------------------------------------*/
extern "C" void W32GC_Forwd(int n)
{
	theView->Forwd(n);
}




/*-------------------------------------------------------------------------*/
/* W32GC_DISPL                                                             */
/*                                                                         */
/*-------------------------------------------------------------------------*/
extern "C" void W32GC_Displ(int n, char *str)
{
	theView->Displ(n, str);
}




/*-------------------------------------------------------------------------*/
/* W32GC_DISPLAY_STRING                                                    */
/*                                                                         */
/*-------------------------------------------------------------------------*/
extern "C" void W32GC_Display_String(char *str)
{
	theView->Display_String(str);
}




/*-------------------------------------------------------------------------*/


/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_UPDATE_COMMAND_UI(ID_INDICATOR_OVR, OnUpdateInsert)
	ON_COMMAND(ID_TOGGLE_INSERT, OnToggleInsert)
	ON_WM_SHOWWINDOW()
	ON_WM_CLOSE()
	ON_UPDATE_COMMAND_UI(ID_TOGGLE_INSERT, OnUpdateInsert)
	//}}AFX_MSG_MAP
	// Global help commands
	ON_COMMAND(ID_HELP_FINDER, CFrameWnd::OnHelpFinder)
	ON_COMMAND(ID_HELP, CFrameWnd::OnHelp)
	ON_COMMAND(ID_CONTEXT_HELP, CFrameWnd::OnContextHelp)
	ON_COMMAND(ID_DEFAULT_HELP, CFrameWnd::OnHelpFinder)
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_OVR,
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	m_bInsert = TRUE;      // default to over-stroke mode
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
			return -1;
	
	if (!m_wndToolBar.CreateEx(this) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}
	m_wndToolBar.SetBarStyle(m_wndToolBar.GetBarStyle() & ~CBRS_HIDE_INPLACE);
	if (!m_wndDlgBar.Create(this, IDR_MAINFRAME,
		CBRS_ALIGN_TOP, AFX_IDW_DIALOGBAR))
	{
		TRACE0("Failed to create dialogbar\n");
		return -1;		// fail to create
	}

	if (!m_wndReBar.Create(this) ||
		!m_wndReBar.AddBar(&m_wndToolBar) ||
		!m_wndReBar.AddBar(&m_wndDlgBar))
	{
		TRACE0("Failed to create rebar\n");
		return -1;      // fail to create
	}
	m_wndReBar.SetBarStyle(m_wndReBar.GetBarStyle() & ~CBRS_HIDE_INPLACE);

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	// TODO: Remove this if you don't want tool tips
	m_wndToolBar.SetBarStyle(m_wndToolBar.GetBarStyle() |
		CBRS_TOOLTIPS | CBRS_FLYBY);

	InitializeCriticalSection(&cs);


	return 0;

}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers


void CMainFrame::OnDestroy()
{
	CFrameWnd::OnDestroy();	
	
}

void CMainFrame::OnUpdateInsert(CCmdUI* pCmdUI)
{
    pCmdUI->SetText((m_bInsert) ? "" : "OVR");
}


void CMainFrame::OnToggleInsert()
{
    m_bInsert = !m_bInsert;	
    theView->ToggleInsert();
}

void CMainFrame::OnShowWindow(BOOL bShow, UINT nStatus)
{
	CFrameWnd::OnShowWindow(bShow, nStatus);
	SetEvent(thread_event);
}


void CMainFrame::OnClose()
{
	(theView->GetDocument())->SetModifiedFlag(FALSE);
    DeleteCriticalSection(&cs);
	
	CFrameWnd::OnClose();
}

